Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
CCM_Base Class Referenceabstract

CCM block cipher base implementation. More...

Inheritance diagram for CCM_Base:

## Public Member Functions
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
size_t | MinKeyLength () const
| Returns smallest valid key length. More...
size_t | MaxKeyLength () const
| Returns largest valid key length. More...
size_t | DefaultKeyLength () const
| Returns default key length. More...
size_t | GetValidKeyLength (size_t keylength) const
| Returns a valid key length for the algorithm. More...
bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs. More...
unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
lword | MaxHeaderLength () const
| Provides the maximum length of AAD that can be input. More...
lword | MaxMessageLength () const
| Provides the maximum length of encrypted data. More...
bool | NeedsPrespecifiedDataLengths () const
| Determines if data lengths must be specified prior to inputting data. More...
void | UncheckedSpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength)
Public Member Functions inherited from AuthenticatedSymmetricCipherBase
bool | IsRandomAccess () const
| Determines whether the cipher supports random access. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
void | SetKey (const byte *userKey, size_t keylength, const NameValuePairs &params)
| Sets or reset the key of this object. More...
void | Restart ()
| Restart the hash. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
void | TruncatedFinal (byte *mac, size_t macSize)
| Computes the hash of the current message. More...
Public Member Functions inherited from AuthenticatedSymmetricCipher
virtual lword | MaxFooterLength () const
| Provides the maximum length of AAD. More...
void | SpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength=0)
| Prescribes the data lengths. More...
virtual void | EncryptAndAuthenticate (byte *ciphertext, byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *message, size_t messageLength)
| Encrypts and calculates a MAC in one call. More...
virtual bool | DecryptAndVerify (byte *message, const byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *header, size_t headerLength, const byte *ciphertext, size_t ciphertextLength)
| Decrypts and verifies a MAC in one call. More...
Public Member Functions inherited from SimpleKeyingInterface
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block. More...
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing. More...
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction. More...

## Additional Inherited Members
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

CCM block cipher base implementation.

Base implementation of the AuthenticatedSymmetricCipher interface

Since
  Crypto++ 5.6.0

Definition at line 18 of file ccm.h.

## Member Function Documentation

## ◆ AlgorithmName()

std::string CCM_Base::AlgorithmName | ( |  | ) | const
| inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like AES or AES/GCM. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 25 of file ccm.h.

## ◆ AlgorithmProvider()

std::string CCM_Base::AlgorithmProvider | ( |  | ) | const
| inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 27 of file ccm.h.

## ◆ MinKeyLength()

size_t CCM_Base::MinKeyLength | ( |  | ) | const
| inline virtual

Returns smallest valid key length.

Returns
  the minimum key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 29 of file ccm.h.

## ◆ MaxKeyLength()

size_t CCM_Base::MaxKeyLength | ( |  | ) | const
| inline virtual

Returns largest valid key length.

Returns
  the maximum key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 31 of file ccm.h.

## ◆ DefaultKeyLength()

size_t CCM_Base::DefaultKeyLength | ( |  | ) | const
| inline virtual

Returns default key length.

Returns
  the default key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 33 of file ccm.h.

## ◆ GetValidKeyLength()

size_t CCM_Base::GetValidKeyLength | ( | size_t | keylength | ) | const
| inline virtual

Returns a valid key length for the algorithm.

Parameters

  keylength | the size of the key, in bytes

Returns
  the valid key length, in bytes

keylength is provided in bytes, not bits. If keylength is less than MIN_KEYLENGTH, then the function returns MIN_KEYLENGTH. If keylength is greater than MAX_KEYLENGTH, then the function returns MAX_KEYLENGTH. if If keylength is a multiple of KEYLENGTH_MULTIPLE, then keylength is returned. Otherwise, the function returns a lower multiple of KEYLENGTH_MULTIPLE.

Implements SimpleKeyingInterface.

Definition at line 35 of file ccm.h.

## ◆ IsValidKeyLength()

bool CCM_Base::IsValidKeyLength | ( | size_t | keylength | ) | const
| inline virtual

Returns whether keylength is a valid key length.

Parameters

  keylength | the requested keylength

Returns
  true if keylength is valid, false otherwise

Internally the function calls GetValidKeyLength()

Reimplemented from SimpleKeyingInterface.

Definition at line 37 of file ccm.h.

## ◆ OptimalDataAlignment()

unsigned int CCM_Base::OptimalDataAlignment | ( |  | ) | const
| inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from StreamTransformation.

Definition at line 39 of file ccm.h.

## ◆ IVRequirement()

IV_Requirement CCM_Base::IVRequirement | ( |  | ) | const
| inline virtual

Minimal requirement for secure IVs.

Returns
  the secure IV requirement of the algorithm

Implements SimpleKeyingInterface.

Definition at line 41 of file ccm.h.

## ◆ IVSize()

unsigned int CCM_Base::IVSize | ( |  | ) | const
| inline virtual

Returns length of the IV accepted by this object.

Returns
  the size of an IV, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

The default implementation throws NotImplemented

Reimplemented from SimpleKeyingInterface.

Definition at line 43 of file ccm.h.

## ◆ MinIVLength()

unsigned int CCM_Base::MinIVLength | ( |  | ) | const
| inline virtual

Provides the minimum size of an IV.

Returns
  minimal length of IVs accepted by this object, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 45 of file ccm.h.

## ◆ MaxIVLength()

unsigned int CCM_Base::MaxIVLength | ( |  | ) | const
| inline virtual

Provides the maximum size of an IV.

Returns
  maximal length of IVs accepted by this object, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 47 of file ccm.h.

## ◆ DigestSize()

unsigned int CCM_Base::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 49 of file ccm.h.

## ◆ MaxHeaderLength()

lword CCM_Base::MaxHeaderLength | ( |  | ) | const
| inline virtual

Provides the maximum length of AAD that can be input.

Returns
  the maximum length of AAD that can be input before the encrypted data

Implements AuthenticatedSymmetricCipher.

Definition at line 51 of file ccm.h.

## ◆ MaxMessageLength()

lword CCM_Base::MaxMessageLength | ( |  | ) | const
| inline virtual

Provides the maximum length of encrypted data.

Returns
  the maximum length of encrypted data

Implements AuthenticatedSymmetricCipher.

Definition at line 53 of file ccm.h.

## ◆ NeedsPrespecifiedDataLengths()

bool CCM_Base::NeedsPrespecifiedDataLengths | ( |  | ) | const
| inline virtual

Determines if data lengths must be specified prior to inputting data.

Returns
  true if the data lengths are required before inputting data, false otherwise

if this function returns true, SpecifyDataLengths() must be called before attempting to input data. This is the case for some schemes, such as CCM.

See also
  SpecifyDataLengths()

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 55 of file ccm.h.

The documentation for this class was generated from the following file:

- ccm.h